﻿using UnityEngine;
using System.IO;
using System.Collections;
using System.Collections.Generic;

public class CardDeck : MonoBehaviour 
{
	[SerializeField]
	private GameObject _cardPrefab;	
	[SerializeField]
	private GameObject _mainCamera;
	[SerializeField]
	private const int _numberOfDeck = 2;
		
	public readonly List<Card> CardList =  new List<Card>();

	public void InstanatiateDeck()
	{
		int i;
		GameObject cardInstance;
		Card card;
		for (i = 0; i < _numberOfDeck; i++) 
		{
			// play with two deck
			int cardValue = 1;
			// Start with Spade to club means 4 times loop play
			for (Card.Suit s = Card.Suit.spade; s <= Card.Suit.club; ++s) 
			{ 
				//Start with Ace to king ace as a low card
				for (Card.Rank r = Card.Rank.ace; r <= Card.Rank.king; ++r) 
				{ 
					cardInstance = (GameObject)Instantiate (_cardPrefab);
					card = cardInstance.GetComponent<Card> ();
					card.transform.parent = Dealer._manage._stackCardSlot.transform;
					card.transform.position = new Vector3 (_mainCamera.transform.position.x, _mainCamera.transform.position.y, _mainCamera.transform.position.z - 5);
					card.transform.eulerAngles = new Vector3 (0, 180, -180);
					card.cardSuit = s;
					card.cardRank = r;
					card.FaceValue = cardValue;

					if(cardValue % 13 == 0)
						card.name = 13 + "_" + s + "_" + cardValue + "_Deck-" + i;
					else
						card.name = cardValue % 13 + "_" + s + "_" + cardValue + "_Deck-" + i;
					
					CardList.Add (card);
					cardValue++;
				}
			}

			for (Card.Rank r = Card.Rank.joker; r <= Card.Rank.joker1; ++r) 
			{ 
				cardInstance = (GameObject)Instantiate (_cardPrefab);
				card = cardInstance.GetComponent<Card> ();
				card.transform.parent = Dealer._manage._stackCardSlot.transform;
				card.transform.position = new Vector3 (_mainCamera.transform.position.x, _mainCamera.transform.position.y, _mainCamera.transform.position.z - 5);
				card.transform.eulerAngles = new Vector3 (0, 180, -180);// Set card Rotation When it's intantiate
				card.cardSuit = Card.Suit.Null;
				card.cardRank = Card.Rank.joker;
				card.FaceValue = cardValue;
				card.name = "" + Card.Rank.joker + "_" + cardValue;
				CardList.Add (card);
				cardValue++;
			}
			ShuffleDeck ();
		}
	}

	// Shuffle the Current Deck of cards
	public void ShuffleDeck()
	{
		for (int suffleNumber = 0; suffleNumber < 10; suffleNumber++) 
		{
			for (int i = CardList.Count - 1; i > 0; --i) 
			{
				int j = Random.Range (0, i + 1);
				Card card = CardList [j];
				CardList [j] = CardList [i];
				CardList [i] = card;
			}
		}
	}

//	public List<Card> Draw(int numberToDraw = 1)
//	{
//		if (numberToDraw > CardList.Count)
//			numberToDraw = CardList.Count;
//
//		List<Card> drawnCards = new List<Card> ();
//
//		for(int i = 0; i < numberToDraw; ++i)
//		{
//			drawnCards.Add (CardList [0]);
//			CardList.RemoveAt (0);
//		}
//		return drawnCards;
//	}
}