﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Deal : MonoBehaviour {

	[SerializeField]
	private CardDeck _cardDeck;	

	[SerializeField]
	private CardSlot _stackCardSlot;	

	private const float CardStackDelay = .01f;

	public int DealInProgress { get; set; }
	// Use this for initialization
	private void Awake()
	{
		_cardDeck.InstanatiateDeck();
		StartCoroutine(StackCardRangeOnSlot(0, _cardDeck.CardList.Count, _stackCardSlot));
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	private IEnumerator StackCardRangeOnSlot(int start, int end, CardSlot cardSlot) 
	{
		DealInProgress++;
		for (int i = start; i < end; ++i)
		{
			cardSlot.AddCard(_cardDeck.CardList[i]);
			yield return new WaitForSeconds(CardStackDelay);
		}
		DealInProgress--;
	}
}
