﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

public class Hand : MonoBehaviour {

	public List<Card> cards;
	public int chainLength;
//	public int rank;

	private Hand hand;

	public int DeadWoodCount = 0;

	[SerializeField]
	bool _treeOfKind = false;
	[SerializeField]
	bool _fourOfkind = false;
	[SerializeField]
	bool _straightThree = false;
	[SerializeField]
	bool _straightFour = false;

//	public int[] tallyMagic = new int[13];

	// Use this for initialization
	void Awake () 
	{
		cards = new List<Card> ();
		Initialize();
	}

	private void Initialize () 
	{
		chainLength = 0;
	}

	public void Clear () 
	{
		foreach (Card card in cards) 
		{
			Destroy(card.gameObject);
		}
		cards.Clear();
		Initialize();
	}


	public bool knock()
	{
		return DeadWoodCount < 10;
	}

	public int DeadWoodCalculation()
	{
		return DeadWoodCount;
	}

	public bool ScoreHand()
	{
//		 _countThreeOfKind = 0;
//		 _countFourOfKind = 0;
		 _treeOfKind = false;
		 _fourOfkind = false;
		 _straightThree = false;
		 _straightFour = false;

//		Card cd = this.hand	;

		int[] tally = new int[13];
		int[] tallyHearts = new int[13];
		int[] tallySpeads = new int[13];
		int[] tallyClubs = new int[13];
		int[] tallyDiamonds = new int[13];
		int[] tallyMagic = new int[13];

		//----------------------------------------------------------------------------------------//

		//Create indivudual card tally

		for(int i = 0; i < this.cards.Count; i++)
		{
			//Add magic/Trump card in tally magic
			if(this.cards[i].cardRank == Dealer._manage.GetTrumpCard ().cardRank)
				tallyMagic [Dealer._manage.GetTrumpCard ().FaceValue % 13]++;
			//Add All Heart Crad
			if (this.cards [i].cardSuit == Card.Suit.heart)
				tallyHearts [this.cards [i].FaceValue % 13]++;
			// Add All Club
			if (this.cards [i].cardSuit == Card.Suit.club)
				tallyClubs [this.cards [i].FaceValue % 13]++;
			//Add All Spade
			if (this.cards [i].cardSuit == Card.Suit.spade)
				tallySpeads [this.cards [i].FaceValue % 13]++;
			//Add All Diomond
			if (this.cards [i].cardSuit == Card.Suit.diomond)
				tallyDiamonds [this.cards [i].FaceValue % 13]++;
			// Add Joker in tallyMagic
			if (this.cards [i].cardSuit == Card.Suit.Null)
				tallyMagic [this.cards [i].FaceValue % 13]++;
		}

		//--------------------------------------------------------------------------------------------------------------------/
		//check for Three Straight

		/// Heart
		///
		for (int i = 0; i <= 10; i++)
			for(int j = 0; j <= 10; j++)
				if ((tallyHearts [i] == 1 || tallyMagic [j] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic [j] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic [j] == 1)) 
				{
					_straightThree = true;
					tallyMagic [j]--;
//					Debug.Log ("Heart Straight 3");
				} 
//			else if ((tallyHearts [i] == 1 || tallyMagic [i + 1] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic [i + 1] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic [i + 1] == 1))
//			{
//				_straightThree = true;
//				tallyMagic [i + 1]--;
////				Debug.Log ("Heart Straight 3");
//			}
//			else if ((tallyHearts [i] == 1 || tallyMagic [i + 2] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic [i + 2] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic [i + 2] == 1))
//			{
//				_straightThree = true;
//				tallyMagic [i + 2]--;
////				Debug.Log ("Heart Straight 3");
//			}

		for (int i = 0; i <= 10; i++)
			for(int j = 0; j <= 10; j++)
				if (tallyClubs [i] == 1 || tallyMagic[j] == 1 && tallyClubs [i + 1] == 1 || tallyMagic[j] == 1 && tallyClubs [i + 2] == 1 || tallyMagic[j] == 1) 
				{
					_straightThree = true;
					tallyMagic [j]--;
//					Debug.Log ("Clubs Straight 3");
				}
//			else if (tallyClubs [i] == 1 || tallyMagic[i + 1] == 1 && tallyClubs [i + 1] == 1 || tallyMagic[i + 1] == 1 && tallyClubs [i + 2] == 1 || tallyMagic[i + 1] == 1) 
//			{
//				_straightThree = true;
//				tallyMagic [i + 1]--;
////				Debug.Log ("Clubs Straight 3");
//			}
//			else if (tallyClubs [i] == 1 || tallyMagic[i + 2] == 1 && tallyClubs [i + 1] == 1 || tallyMagic[i + 2] == 1 && tallyClubs [i + 2] == 1 || tallyMagic[i + 2] == 1)
//			{
//				_straightThree = true;
//				tallyMagic [i + 2]--;
////				Debug.Log ("Clubs Straight 3");
//			}

		for (int i = 0; i <= 10; i++)
			for(int j = 0; j <= 10; j++)
				if (tallySpeads [i] == 1 || tallyMagic[j] == 1 && tallySpeads [i + 1] == 1 || tallyMagic[j] == 1 && tallySpeads [i + 2] == 1 || tallyMagic[j] == 1) 
				{
					_straightThree = true;
					tallyMagic [j]--;
//					Debug.Log ("Speads Straight 3");
				}
//			else if (tallySpeads [i] == 1 || tallyMagic[i + 1] == 1 && tallySpeads [i + 1] == 1 || tallyMagic[i + 1] == 1 && tallySpeads [i + 2] == 1 || tallyMagic[i + 1] == 1) 
//			{
//				_straightThree = true;
//				tallyMagic [i + 1]--;
////				Debug.Log ("Speads Straight 3");
//			}
//			else if (tallySpeads [i] == 1 || tallyMagic[i + 2] == 1 && tallySpeads [i + 1] == 1 || tallyMagic[i + 2] == 1 && tallySpeads [i + 2] == 1 || tallyMagic[i + 2] == 1) 
//			{
//				_straightThree = true;
//				tallyMagic [i + 2]--;
////				Debug.Log ("Speads Straight 3");
//			}
	

		for (int i = 0; i <= 10; i++)
			for(int j = 0; j <= 10; j++)
				if (tallyDiamonds [i] == 1 || tallyMagic[j] == 1 && tallyDiamonds [i + 1] == 1 || tallyMagic[j] == 1 && tallyDiamonds [i + 2] == 1 || tallyMagic[j] == 1) 
				{
					_straightThree = true;
					tallyMagic [j]--;
//					Debug.Log ("Diamonds Straight 3");
				}
//			else if (tallyDiamonds [i] == 1 || tallyMagic[i + 1] == 1 && tallyDiamonds [i + 1] == 1 || tallyMagic[i + 1] == 1 && tallyDiamonds [i + 2] == 1 || tallyMagic[i + 1] == 1) 
//			{
//				_straightThree = true;
//				tallyMagic [i + 1]--;
////				Debug.Log ("Diamonds Straight 3");
//			}
//			else if (tallyDiamonds [i] == 1 || tallyMagic[i + 2] == 1 && tallyDiamonds [i + 1] == 1 || tallyMagic[i + 2] == 1 && tallyDiamonds [i + 2] == 1 || tallyMagic[i + 2] == 1) 
//			{
//				_straightThree = true;
//				tallyMagic [i + 2]--;
////				Debug.Log ("Diamonds Straight 3");
//			}


		//--------------------------------------------------------------------------------------------------------------------//

		//check for four straight
		for (int i = 0; i <= 9; i++)
			for(int j = 0; j <= 9; j++)
				if ((tallyHearts [i] == 1 || tallyMagic[j] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic[j] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic[j] == 1) && (tallyHearts [i + 3] == 1 || tallyMagic[j] == 1)) 
				{
					_straightFour = true;
					tallyMagic [j]--;
					//					Debug.Log ("Heart Straight 4");
				}
		//			else if ((tallyHearts [i] == 1 || tallyMagic[i + 1] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic[i + 1] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic[i + 1] == 1) && (tallyHearts [i + 3] == 1 || tallyMagic[i + 1] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 1]--;
		//				Debug.Log ("Heart Straight 4");
		//			}
		//			else if ((tallyHearts [i] == 1 || tallyMagic[i + 2] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic[i + 2] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic[i + 2] == 1) && (tallyHearts [i + 3] == 1 || tallyMagic[i + 2] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 2]--;
		//				//Debug.Log ("Heart Straight 4");
		//			}
		//			else if ((tallyHearts [i] == 1 || tallyMagic[i + 3] == 1) && (tallyHearts [i + 1] == 1 || tallyMagic[i + 3] == 1) && (tallyHearts [i + 2] == 1 || tallyMagic[i + 3] == 1) && (tallyHearts [i + 3] == 1 || tallyMagic[i + 3] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 3]--;
		//				Debug.Log ("Heart Straight 4");
		//			}

		for (int i = 0; i <= 9; i++)
			for(int j = 0; j <= 9; j++)
				if ((tallyClubs [i] == 1 || tallyMagic[j] == 1) && (tallyClubs [i + 1] == 1 || tallyMagic[j] == 1) && (tallyClubs [i + 2] == 1 || tallyMagic[j] == 1) && (tallyClubs [i + 3] == 1 || tallyMagic[j] == 1)) 
				{
					_straightFour = true;
					tallyMagic [j]--;
					//					Debug.Log ("Clubs Straight 4");
				}
		//			else if ((tallyClubs [i] == 1 || tallyMagic[i + 1] == 1) && (tallyClubs [i + 1] == 1 || tallyMagic[i + 1] == 1) && (tallyClubs [i + 2] == 1 || tallyMagic[i + 1] == 1) && (tallyClubs [i + 3] == 1 || tallyMagic[i + 1] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 1]--;
		////				Debug.Log ("Clubs Straight 4");
		//			}
		//			else if ((tallyClubs [i] == 1 || tallyMagic[i + 2] == 1) && (tallyClubs [i + 1] == 1 || tallyMagic[i + 2] == 1) && (tallyClubs [i + 2] == 1 || tallyMagic[i + 2] == 1) && (tallyClubs [i + 3] == 1 || tallyMagic[i + 2] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 2]--;
		////				Debug.Log ("Clubs Straight 4");
		//			}
		//			else if ((tallyClubs [i] == 1 || tallyMagic[i + 3] == 1) && (tallyClubs [i + 1] == 1 || tallyMagic[i + 3] == 1) && (tallyClubs [i + 2] == 1 || tallyMagic[i + 3] == 1) && (tallyClubs [i + 3] == 1 || tallyMagic[i + 3] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 3]--;
		////				Debug.Log ("Clubs Straight 4");
		//			}

		for (int i = 0; i <= 9; i++)
			for(int j = 0; j <= 9; j++)
				if ((tallySpeads [i] == 1 || tallyMagic[j] == 1) && (tallySpeads [i + 1] == 1 || tallyMagic[j] == 1) && (tallySpeads [i + 2] == 1 || tallyMagic[j] == 1) && (tallySpeads [i + 3] == 1 || tallyMagic[j] == 1)) 
				{
					_straightFour = true;
					tallyMagic [j]--;
					//					Debug.Log ("Speads Straight 4");
				}
		//			else if ((tallySpeads [i] == 1 || tallyMagic[i + 1] == 1) && (tallySpeads [i + 1] == 1 || tallyMagic[i + 1] == 1) && (tallySpeads [i + 2] == 1 || tallyMagic[i + 1] == 1) && (tallySpeads [i + 3] == 1 || tallyMagic[i + 1] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 1]--;
		////				Debug.Log ("Speads Straight 4");
		//			}
		//			else if ((tallySpeads [i] == 1 || tallyMagic[i + 2] == 1) && (tallySpeads [i + 1] == 1 || tallyMagic[i + 2] == 1) && (tallySpeads [i + 2] == 1 || tallyMagic[i + 2] == 1) && (tallySpeads [i + 3] == 1 || tallyMagic[i + 2] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 2]--;
		////				Debug.Log ("Speads Straight 4");
		//			}
		//			else if ((tallySpeads [i] == 1 || tallyMagic[i + 3] == 1) && (tallySpeads [i + 1] == 1 || tallyMagic[i + 3] == 1) && (tallySpeads [i + 2] == 1 || tallyMagic[i + 3] == 1) && (tallySpeads [i + 3] == 1 || tallyMagic[i + 3] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 3]--;
		////				Debug.Log ("Speads Straight 4");
		//			}

		for (int i = 0; i <= 9; i++)
			for(int j = 0; j <= 9; j++)
				if ((tallyDiamonds [i] == 1 || tallyMagic[j] == 1) && (tallyDiamonds [i + 1] == 1 || tallyMagic[j] == 1) && (tallyDiamonds [i + 2] == 1 || tallyMagic[j] == 1) && (tallyDiamonds [i + 3] == 1 || tallyMagic[j] == 1)) 
				{
					_straightFour = true;
					tallyMagic [j]--;
					//					Debug.Log ("Diamonds Straight 4");
				}
		//			else if ((tallyDiamonds [i] == 1 || tallyMagic[i + 1] == 1) && (tallyDiamonds [i + 1] == 1 || tallyMagic[i + 1] == 1) && (tallyDiamonds [i + 2] == 1 || tallyMagic[i + 1] == 1) && (tallyDiamonds [i + 3] == 1 || tallyMagic[i + 1] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 1]--;
		////				Debug.Log ("Diamonds Straight 4");
		//			}
		//			else if ((tallyDiamonds [i] == 1 || tallyMagic[i + 2] == 1) && (tallyDiamonds [i + 1] == 1 || tallyMagic[i + 2] == 1) && (tallyDiamonds [i + 2] == 1 || tallyMagic[i + 2] == 1) && (tallyDiamonds [i + 3] == 1 || tallyMagic[i + 2] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 2]--;
		////				Debug.Log ("Diamonds Straight 4");
		//			}
		//			else if ((tallyDiamonds [i] == 1 || tallyMagic[i + 3] == 1) && (tallyDiamonds [i + 1] == 1 || tallyMagic[i + 3] == 1) && (tallyDiamonds [i + 2] == 1 || tallyMagic[i + 3] == 1) && (tallyDiamonds [i + 3] == 1 || tallyMagic[i + 3] == 1)) 
		//			{
		//				_straightFour = true;
		//				tallyMagic [i + 3]--;
		////				Debug.Log ("Diamonds Straight 4");
		//			}

		//----------------------------------------------------------------------------------------------------//

		//tally chart
		for (int i = 0; i < 13; i++)
			tally [this.cards [i].FaceValue % 13]++;

		//check for Three of kind
		for (int i = 0; i < 13; i++)
			if (tally [i] == 3) 
			{
				_treeOfKind = true;
			}
			else if(tally[i] == 2)
			{
				for(int j=0; j < 13; j++)
				{
					if(tally[i] == 2 && tallyMagic[j] == 1)
					{
						_treeOfKind = true;
						tallyMagic [j]--;
//						return 0;
					}
				}
			}
			else if(tally[i] == 1)
			{
				for(int j = 0; j < 12; j++)
				{
					if(tally[i] == 1 && tallyMagic[j] == 1 && tallyMagic[j + 1] == 1)
					{
						_treeOfKind = true;
						tallyMagic [j]--;
						tallyMagic [j + 1]--;
//						return 0;
					}
				}
			}

		for (int i = 0; i < 13; i++)
			if (tally [i] == 4)
				_fourOfkind = true;
			else if (tally [i] == 3) 
			{
				for(int j = 0; j < 12; j++)
				{
					if(tally[i] == 3 && tallyMagic[j] == 1)
					{
						_fourOfkind = true;
						tallyMagic [j]--;
					}
				}
			}
			else if (tally [i] == 2) 
			{
				for(int j = 0; j < 11; j++)
				{
					if(tally[i] == 2 && tallyMagic[j] == 1 && tallyMagic[j + 1] == 1)
					{
						_fourOfkind = true;
						tallyMagic [j]--;
						tallyMagic [j + 1]--;
					}
				}
			}
			else if (tally [i] == 1) 
			{
				for(int j = 0; j < 10; j++)
				{
					if(tally[i] == 2 && tallyMagic[j] == 1 && tallyMagic[j + 1] == 1 && tallyMagic[j + 2] == 1)
					{
						_fourOfkind = true;
						tallyMagic [j]--;
						tallyMagic [j + 1]--;
						tallyMagic[j + 2]-- ;
					}
				}
			}

		//--------------------------------------------------------------------------------------------------//

		//At List One run in Hand for Declare Game
		if (_treeOfKind == true && _straightFour == true)
			return true;
		if (_fourOfkind == true && _straightThree == true)
			return true;
		if (_straightThree == true && _straightFour == true)
			return true;

		return false;
	}
}
